---
title: Object.prototype.__defineSetter__()
slug: Web/JavaScript/Reference/Global_Objects/Object/__defineSetter__
tags:
  - Deprecated
  - JavaScript
  - Method
  - Object
  - Prototype
---
<div>{{JSRef}}</div>

<div class="warning">
<p>This feature is deprecated in favor of defining setters using the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">object initializer syntax</a> or the {{jsxref("Object.defineProperty()")}} API.</p>

<p>However, as it is widely implemented and used on the Web, it is very unlikely that browsers will stop implementing it.</p>
</div>

<p>The <code><strong>__defineSetter__</strong></code> method binds an object's property to a function to be called when an attempt is made to set that property.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>obj</var>.__defineSetter__(<var>prop</var>, <var>fun</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>prop</var></code></dt>
 <dd>A string containing the name of the property to be bound to the given function.</dd>
 <dt><code><var>fun</var></code></dt>
 <dd>A function to be called when there is an attempt to set the specified property. This function takes the form
 <pre class="brush: js notranslate">function(<var>val</var>) { . . . }</pre>

 <dl>
  <dt><code><var>val</var></code></dt>
  <dd>An alias for the variable that holds the value attempted to be assigned to <code><var>prop</var></code>.</dd>
 </dl>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>__defineSetter__</code> method allows a {{jsxref("Operators/set", "setter", "", 1)}} to be defined on a pre-existing object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Non-standard_and_deprecated_way">Non-standard and deprecated way</h3>

<pre class="brush: js notranslate">var o = {};
o.__defineSetter__('value', function(val) { this.anotherValue = val; });
o.value = 5;
console.log(o.value); // undefined
console.log(o.anotherValue); // 5
</pre>

<h3 id="Standard-compliant_ways">Standard-compliant ways</h3>

<pre class="brush: js notranslate">// Using the set operator
var o = { set value(val) { this.anotherValue = val; } };
o.value = 5;
console.log(o.value); // undefined
console.log(o.anotherValue); // 5

// Using Object.defineProperty
var o = {};
Object.defineProperty(o, 'value', {
  set: function(val) {
    this.anotherValue = val;
  }
});
o.value = 5;
console.log(o.value); // undefined
console.log(o.anotherValue); // 5
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.prototype.__defineSetter__', 'Object.prototype.__defineSetter__()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Object.defineSetter")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.prototype.__defineGetter__()")}}</li>
 <li>{{jsxref("Operators/set", "set")}} operator</li>
 <li>{{jsxref("Object.defineProperty()")}}</li>
 <li>{{jsxref("Object.prototype.__lookupGetter__()")}}</li>
 <li>{{jsxref("Object.prototype.__lookupSetter__()")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Defining_getters_and_setters">JS Guide: Defining Getters and Setters</a></li>
 <li><a href="http://whereswalden.com/2010/04/16/more-spidermonkey-changes-ancient-esoteric-very-rarely-used-syntax-for-creating-getters-and-setters-is-being-removed/">[Blog Post] Deprecation of __defineGetter__ and __defineSetter__</a></li>
 <li>{{bug(647423)}}</li>
</ul>
